﻿namespace ProjectAccordionBus.Drawnings;

/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawningBusCompareByColor : IComparer<DrawningBus?>
{
    public int Compare(DrawningBus? x, DrawningBus? y)
    {
        if (x == null || x.EntityBus == null)
        {
            return 1;
        }

        if (y == null || y.EntityBus == null)
        {
            return -1;
        }

        var bodycolorCompare = x.EntityBus.BodyColor.Name.CompareTo(y.EntityBus.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }

        var speedCompare = x.EntityBus.Speed.CompareTo(y.EntityBus.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityBus.Weight.CompareTo(y.EntityBus.Weight);
    }
}
