﻿namespace ProjectAccordionBus.Drawnings;

/// <summary>
/// Сравнение по типу, скорости и весу
/// </summary>
public class DrawningBusCompareByType : IComparer<DrawningBus?>
{
    public int Compare(DrawningBus? x, DrawningBus? y)
    {
        if (x == null && y == null)
        {
            return 0;
        }

        if (x == null || x.EntityBus == null)
        {
            return 1;
        }

        if (y == null || y.EntityBus == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityBus.Speed.CompareTo(y.EntityBus.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityBus.Weight.CompareTo(y.EntityBus.Weight);
    }
}
