﻿using ProjectAccordionBus.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectAccordionBus.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningBusEqutables : IEqualityComparer<DrawningBus?>
{
    public bool Equals(DrawningBus? x, DrawningBus? y)
    {
        if (x == null || x.EntityBus == null)
        {
            return false;
        }

        if (y == null || y.EntityBus == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityBus.Speed != y.EntityBus.Speed)
        {
            return false;
        }

        if (x.EntityBus.Weight != y.EntityBus.Weight)
        {
            return false;
        }

        if (x.EntityBus.BodyColor != y.EntityBus.BodyColor)
        {
            return false;
        }

        if (x is DrawningAccordionBus && y is DrawningAccordionBus)
        {
            // TODO доделать логику сравнения дополнительных параметров
            EntityAccordionBus _x = (EntityAccordionBus)x.EntityBus;
            EntityAccordionBus _y = (EntityAccordionBus)y.EntityBus;

            if (_x.Compartment != _y.Compartment)
            {
                if (_x.Entrance != _y.Entrance)
                {
                    return false;
                }
                if (_x.Windows != _y.Windows)
                {
                    return false;
                }
                return false;
            }
            
            if (_x.AdditionalColor != _y.AdditionalColor)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawningBus obj)
    {
        return obj.GetHashCode();
    }
}

