﻿using System.Runtime.Serialization;

namespace ProjectAirbus.Exceptions;

/// <summary>
/// Класс, описывающий ошибку наличия такого же объекта в коллекции
/// </summary>
[Serializable]
internal class ObjectNotUniqueException : ApplicationException
{
    public ObjectNotUniqueException(int i) : base("В коллекции есть такой же элемент на позиции: " + i) { }

    public ObjectNotUniqueException() : base() { }

    public ObjectNotUniqueException(string message) : base(message) { }

    public ObjectNotUniqueException(string message, Exception exception) : base(message, exception) { }

    protected ObjectNotUniqueException(SerializationInfo info, StreamingContext context) : base(info, context) { }
}